from nodebox.client import NetworkView
from nodebox.graphics import Color


def getNodeNames(context):
    library = context.nodeLibrary    
    nodeRepository = library.getNodeRepository()    
    nodes=nodeRepository.getNodes()
    names=[]
    for node in nodes:
        names.append(node.getName())
        names.append(node.getCategory())
        names.append(node.getOutputType())
        names.append(node.getDescription())
    return names
  

def getPortInfo(context):
    library = context.nodeLibrary    
    nodeRepository = library.getNodeRepository()    
    nodes=nodeRepository.getNodes()
    names=[]
    for node in nodes:
        ports=node.getInputs()
        for port in ports:
            c = NetworkView.portTypeColor(port.getType())
            r=c.red
            g=c.green
            b=c.blue
            names.append(node.getName()
                + '|' + port.getName()
                + '|' + port.getType()
                + '|' + str(port.getRange())
                + '|' + str(port.getValue())
                + '|' + str(r) + '|' + str(g) + '|' + str(b)
                + '|' + port.getDescription())

    return names

    
    
def getNodeIcons(context,nodeName,other):
    library = context.nodeLibrary    
    nodeRepository = library.getNodeRepository()   
    nodes=nodeRepository.getNodes()
    for node in nodes:
        thisNode = node.getName()
        thisCategory = node.getCategory()
        if other == True and thisCategory != 'geometry' and (nodeName == 'reflect' or nodeName == 'sort'): thisNode = 'skip'

        if nodeName == thisNode:
            all = []
            bi=NetworkView.getImageForNode(node,nodeRepository)
            raster = bi.raster
            rType = raster.numDataElements
            w = raster.width
            h = raster.height
            for i in [int(x) for x in range(0, int(h))]:
                for j in [int(x) for x in range(0, int(w))]:
                    c = bi.raster.getPixel(j,i,[0.0,0.0,0.0,0.0])
                    all.append(c[1])
            return all

    return 0


def getNodeColor(context,nodeName,other):
    library = context.nodeLibrary    
    nodeRepository = library.getNodeRepository()   
    nodes=nodeRepository.getNodes()
    for node in nodes:
        thisNode = node.getName()
        thisCategory = node.getCategory()
        if other == True and thisCategory != 'geometry' and (nodeName == 'reflect' or nodeName == 'sort'): thisNode = 'skip'
        if nodeName == thisNode:
            return NetworkView.portTypeColor(node.getOutputType())

    return 0

